C********0*********0*********0*********0*********0*********0*********0
C  Test program to check SVD routine is working as expected
C********0*********0*********0*********0*********0*********0*********0
       PROGRAM svdtest
       IMPLICIT none
       INTEGER udatlog
       COMPLEX*16 cmat(4,4)
       COMPLEX*16 uout(4,4), vout(4,4)
       DOUBLE PRECISION sing(4)
       INTEGER i,j,k
       COMPLEX*16 csum, cterm

       udatlog=6

C      ...enter example complex 4x4 matrix
       cmat(1,1)=(1.0,0.0)
       cmat(1,2)=(1.0,1.0)
       cmat(1,3)=(2.0,1.0)
       cmat(1,4)=(1.0,-1.0)
       cmat(2,1)=(1.0,-0.5)
       cmat(2,2)=(1.0,-1.0)
       cmat(2,3)=(-2.0,1.0)
       cmat(2,4)=(-1.0,-1.0)
       cmat(3,1)=(0.0,-0.5)
       cmat(3,2)=(0.0,-1.0)
       cmat(3,3)=(-2.0,1.0)
       cmat(3,4)=(-0.0,-1.0)
       cmat(4,1)=(0.0, 0.5)
       cmat(4,2)=(0.0, 1.0)
       cmat(4,3)=(-2.0,-1.0)
       cmat(4,4)=(-0.0, 1.0)


       CALL svdexpmat(udatlog,cmat,uout,vout,sing)

C      ...outputs
       write(udatlog,*) 'Principal values:'
       do i=1,4
         write(udatlog,*) sing(i)
       enddo
       write(udatlog,*) 'Right singular vectors, U_out:'
       do i=1,4
         write(udatlog,1001) uout(i,1),uout(i,2),uout(i,3),uout(i,4)
       enddo
       write(udatlog,*) 'Left singular vectors, V_out:'
       do i=1,4
         write(udatlog,1001) vout(i,1),vout(i,2),vout(i,3),vout(i,4)
       enddo
 1001  format(2x,4('(',e12.5,',',e12.5,')',2x))

C      ...reconstruction check cmat = V . Sigma. U^
       write(udatlog,*) ' '
       write(udatlog,*) 'Reconstruct cmat and compare with original.'
       write(udatlog,*) ' '

       do i=1,4
         do j=1,4
           csum=0.0
           do k=1,4
             cterm=vout(i,k)*sing(k)*dconjg(uout(j,k))
             csum=csum+cterm
           enddo
           write(udatlog,1002) i,j,cmat(i,j),csum
         enddo
       enddo
 1002  format(' cmat(',i1,',',i1,')=(',e10.4,',',e10.4,')',5x,
     &        ' reconstructed = (',e10.4,',',e10.4,')')

       STOP  
       END

